;Copyright (C) 2004-2006 John T. Haller
;Additional concepts from tracon and mai9

;This file was created and compiled by Ady Romantika (romantika.name)
;This file launches the GTK Theme Selector (gtkthemeselector.exe)

;Website: http://PortableApps.com/GaimPortable

;This software is OSI Certified Open Source Software.
;OSI Certified is a certification mark of the Open Source Initiative.

;This program is free software; you can redistribute it and/or
;modify it under the terms of the GNU General Public License
;as published by the Free Software Foundation; either version 2
;of the License, or (at your option) any later version.

;This program is distributed in the hope that it will be useful,
;but WITHOUT ANY WARRANTY; without even the implied warranty of
;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;GNU General Public License for more details.

;You should have received a copy of the GNU General Public License
;along with this program; if not, write to the Free Software
;Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

!define NAME "PidginPortableGTKThemeSelector"
!define FRIENDLYNAME "Pidgin Portable GTK Theme Selector"
!define APP "PidginGTKThemeSelector"
!define VER "1.2.0.5"
!define WEBSITE "http://www.romantika.name/v2/2007/05/09/my-version-of-pidgin-portable"
!define DEFAULTEXE "gtkthemeselector.exe"
!define DEFAULTAPPDIR "gtk"
!define DEFAULTSETTINGSDIR "settings"
!define DEFAULTGTKDIR "gtk"

;=== Program Details
Name "${NAME}"
OutFile "${NAME}.exe"
Caption "${FRIENDLYNAME} | PortableApps.com | romantika.name"
VIProductVersion "${VER}"
VIAddVersionKey ProductName "${FRIENDLYNAME}"
VIAddVersionKey Comments "Allows ${APP} to be run from a removable drive. For additional details, visit ${WEBSITE}"
VIAddVersionKey CompanyName "romantika.name (Ady Romantika)"
VIAddVersionKey LegalCopyright "John T. Haller, Ady Romantika"
VIAddVersionKey FileDescription "${FRIENDLYNAME}"
VIAddVersionKey FileVersion "${VER}"
VIAddVersionKey ProductVersion "${VER}"
VIAddVersionKey InternalName "${FRIENDLYNAME}"
VIAddVersionKey LegalTrademarks "Based on GAIM Portable by PortableApps.com (John T. Haller). PortableApps.com is a Trademark of Rare Ideas, LLC."
VIAddVersionKey OriginalFilename "${NAME}.exe"
;VIAddVersionKey PrivateBuild ""
;VIAddVersionKey SpecialBuild ""


;=== Runtime Switches
CRCCheck On
WindowIcon Off
SilentInstall Silent
AutoCloseWindow True
RequestExecutionLevel user

;=== Include
!include "GetParameters.nsh"

;=== Program Icon
Icon "${NAME}.ico"

Var PROGRAMDIRECTORY
Var GTKDIRECTORY
Var ASPELLDIRECTORY
Var SETTINGSDIRECTORY
Var ADDITIONALPARAMETERS
Var EXECSTRING
Var WAITFORPROGRAM
Var PROGRAMEXECUTABLE
Var ISDEFAULTDIRECTORY

Section "Main"
		;=== No INI file, so we'll use the defaults
		StrCpy "$ADDITIONALPARAMETERS" ""
		StrCpy "$WAITFORPROGRAM" "false"
		StrCpy "$PROGRAMEXECUTABLE" "${DEFAULTEXE}"

		StrCpy "$PROGRAMDIRECTORY" "$EXEDIR\App\${DEFAULTAPPDIR}\bin"
		StrCpy "$GTKDIRECTORY" "$EXEDIR\App\${DEFAULTGTKDIR}"
		StrCpy "$ASPELLDIRECTORY" "$EXEDIR\App\aspell"
		StrCpy "$SETTINGSDIRECTORY" "$EXEDIR\Data\${DEFAULTSETTINGSDIR}"
		StrCpy "$ISDEFAULTDIRECTORY" "true"
		IfFileExists "$PROGRAMDIRECTORY\$PROGRAMEXECUTABLE" FoundProgramEXE

		;=== Program executable not where expected
		MessageBox MB_OK|MB_ICONEXCLAMATION `$PROGRAMEXECUTABLE was not found.  Please check your configuration`
		Abort

	FoundProgramEXE:
		;=== Get any passed parameters
		Call GetParameters
		Pop $0
		StrCmp "'$0'" "''" "" LaunchProgramParameters

		;=== No parameters
		StrCpy $EXECSTRING `"$PROGRAMDIRECTORY\$PROGRAMEXECUTABLE"`
		Goto AdditionalParameters

	LaunchProgramParameters:
		StrCpy $EXECSTRING `"$PROGRAMDIRECTORY\$PROGRAMEXECUTABLE" $0`

	AdditionalParameters:
		StrCmp $ADDITIONALPARAMETERS "" GTKEnvironment

		;=== Additional Parameters
		StrCpy $EXECSTRING `$EXECSTRING $ADDITIONALPARAMETERS`

	GTKEnvironment:
		;=== Set the %PURPLEHOME% directory if we have a path
		StrCmp $SETTINGSDIRECTORY "" GTKSettingsNotFound
		IfFileExists "$SETTINGSDIRECTORY\*.*" GTKDirectory

	GTKSettingsNotFound:
		StrCmp $ISDEFAULTDIRECTORY "true" SetupDefaultSettings
		MessageBox MB_OK|MB_ICONEXCLAMATION `$SETTINGSDIRECTORY was not found.  Please check your configuration`
		Abort

	SetupDefaultSettings:
		CreateDirectory "$EXEDIR\Data"
		CreateDirectory "$EXEDIR\Data\settings"
		CopyFiles /SILENT $EXEDIR\App\DefaultData\settings\*.* $EXEDIR\Data\settings

	GTKDirectory:
		;=== Add GTK to the %PATH% directory if we have a path, otherwise, skip it
		StrCmp $GTKDIRECTORY "" GTKNotFound
		IfFileExists "$GTKDIRECTORY\*.*" "" GTKNotFound
		StrCpy $0 "$GTKDIRECTORY\bin;$PROGRAMDIRECTORY"
		System::Call 'Kernel32::SetEnvironmentVariableA(t, t) i("PATH", "$0").r0'
		System::Call 'Kernel32::SetEnvironmentVariableA(t, t) i("GTK_BASEPATH", "$GTKDIRECTORY").r0'
		System::Call 'Kernel32::SetEnvironmentVariableA(t, t) i("HOME", "$SETTINGSDIRECTORY\.purple").r0'
		GoTo LaunchAndWait

	GTKNotFound:
		MessageBox MB_OK|MB_ICONEXCLAMATION `$GTKDIRECTORY was not found.  Please check your configuration`
		Abort

	LaunchAndWait:
		ExecWait $EXECSTRING
		;2-Aug-2007 - disabled file copying as home is now correctly set so .gtkrc (notice the dot) is effective
		;CopyFiles /SILENT $SETTINGSDIRECTORY\.purple\.gtkrc-2.0 $SETTINGSDIRECTORY\.purple\gtkrc-2.0
		GoTo TheEnd
	TheEnd:

SectionEnd